%global erlang_minver 25
%global _rabbit_libdir %{_exec_prefix}/lib/rabbitmq
%global debug_package %{nil}
%bcond_with test


Summary: The RabbitMQ server
Name: rabbitmq-server
Version: 3.12.11
Release: 1%{?dist}
License: MPLv1.1
URL: https://www.rabbitmq.com/
Source0: https://github.com/rabbitmq/rabbitmq-server/releases/download/v%{version}/%{name}_%{version}.orig.tar.xz
# curl -O https://raw.githubusercontent.com/rabbitmq/rabbitmq-server-release/rabbitmq_v3_6_16/packaging/RPMS/Fedora/rabbitmq-server.tmpfiles
Source1: rabbitmq-server.tmpfiles
# curl -O https://raw.githubusercontent.com/lemenkov/rabbitmq-server/cdfc661/packaging/RPMS/Fedora/rabbitmq-server.logrotate
Source2: rabbitmq-server.logrotate

Patch3000: rabbitmq-server-0001-Allow-guest-login-from-non-loopback-connections.patch
Patch3001: rabbitmq-server-0002-Use-default-EPMD-socket.patch
Patch3002: rabbitmq-server-0003-Use-proto_dist-from-command-line.patch
Patch3003: rabbitmq-server-0004-force-python3.patch
Patch3004: rabbitmq-server-0005-Partially-revert-Use-template-in-rabbitmq-script-wra.patch

BuildRequires: make elixir erlang >= %{erlang_minver}
BuildRequires: hostname libxslt python3 python3-simplejson rsync
BuildRequires: systemd xmlto zip

Requires: logrotate
Requires: erlang-erts >= %{erlang_minver}
Requires: erlang-kernel >= %{erlang_minver}
Requires: erlang-eldap >= %{erlang_minver}
Requires: erlang-mnesia >= %{erlang_minver}
Requires: erlang-os_mon >= %{erlang_minver}
Requires: erlang-public_key >= %{erlang_minver}
Requires: erlang-sasl >= %{erlang_minver}
Requires: erlang-ssl >= %{erlang_minver}
Requires: erlang-stdlib >= %{erlang_minver}
Requires: erlang-syntax_tools >= %{erlang_minver}
Requires: erlang-tools >= %{erlang_minver}
Requires: erlang-xmerl >= %{erlang_minver}
Requires(pre): shadow-utils
Requires(pre): systemd
Requires(post): systemd
Requires(preun): systemd

%description
RabbitMQ is an implementation of AMQP, the emerging standard for high
performance enterprise messaging. The RabbitMQ server is a robust and
scalable implementation of an AMQP broker.

%prep
%autosetup -p1

rm -f \
	deps/amqp_client/src/rabbit_ct_client_helpers.erl \
	deps/rabbit_common/src/rabbit_ct_broker_helpers.erl \
	deps/rabbit_common/src/rabbit_ct_helpers.erl

%build
%make_build VERSION="%{version}"


%install
%make_install \
	VERSION="%{version}" \
	PREFIX=%{_prefix} \
	RMQ_ROOTDIR=%{_rabbit_libdir}

make install-man \
	VERSION="%{version}" \
	DESTDIR=%{buildroot} \
	PREFIX=%{_prefix} \
	RMQ_ROOTDIR=%{_rabbit_libdir}

mkdir -p %{buildroot}%{_localstatedir}/lib/rabbitmq/mnesia
mkdir -p %{buildroot}%{_localstatedir}/log/rabbitmq

install -p -D -m0644 ./deps/rabbit/docs/rabbitmq-server.service.example %{buildroot}%{_unitdir}/%{name}.service
install -p -D -m0755 ./scripts/rabbitmq-script-wrapper %{buildroot}%{_sbindir}/rabbitmqctl
install -p -D -m0755 ./scripts/rabbitmq-script-wrapper %{buildroot}%{_sbindir}/rabbitmq-server
install -p -D -m0755 ./scripts/rabbitmq-script-wrapper %{buildroot}%{_sbindir}/rabbitmq-plugins
install -p -D -m0755 ./scripts/rabbitmq-script-wrapper %{buildroot}%{_sbindir}/rabbitmq-diagnostics

mkdir -p %{buildroot}%{_rabbit_libdir}/bin
for app in rabbitmq-defaults rabbitmq-env rabbitmq-plugins rabbitmq-diagnostics rabbitmq-server rabbitmqctl ; do
	ln -s %{_rabbit_libdir}/lib/rabbitmq_server-%{version}/sbin/${app} %{buildroot}%{_rabbit_libdir}/bin/${app}
done

install -p -D -m 0755 %{SOURCE2} %{buildroot}%{_rabbit_libdir}/bin/cuttlefish

install -p -D -m 0755 scripts/rabbitmq-server.ocf %{buildroot}%{_exec_prefix}/lib/ocf/resource.d/rabbitmq/rabbitmq-server

install -p -D -m 0644 %{SOURCE2} %{buildroot}%{_sysconfdir}/logrotate.d/rabbitmq-server

install -p -D -m 0644 ./deps/rabbit/docs/rabbitmq.conf.example %{buildroot}%{_sysconfdir}/rabbitmq/rabbitmq.conf

install -d %{buildroot}%{_localstatedir}/run/rabbitmq
install -p -D -m 0644 %{SOURCE1} %{buildroot}%{_prefix}/lib/tmpfiles.d/%{name}.conf

%if %{with test}
%check
make check
%endif

%pre
if ! getent group rabbitmq >/dev/null; then
        groupadd -r rabbitmq
fi

if ! getent passwd rabbitmq >/dev/null; then
        useradd -r -g rabbitmq -d %{_localstatedir}/lib/rabbitmq rabbitmq \
            -s /sbin/nologin -c "RabbitMQ messaging server"
fi


%post
%systemd_post %{name}.service
systemctl daemon-reload


%preun
%systemd_preun %{name}.service

rm -rf %{_localstatedir}/lib/rabbitmq/plugins
for ext in rel script boot ; do
    rm -f %{_rabbit_libdir}/lib/rabbitmq_server-%{version}/ebin/rabbit.$ext
done


%postun
%systemd_postun_with_restart %{name}.service


%files
%license LICENSE LICENSE-*
%{_sbindir}/rabbitmqctl
%{_sbindir}/rabbitmq-server
%{_sbindir}/rabbitmq-plugins
%{_sbindir}/rabbitmq-diagnostics
%dir %attr(0755, rabbitmq, rabbitmq) %{_sysconfdir}/rabbitmq
%config(noreplace) %attr(0644, rabbitmq, rabbitmq) %{_sysconfdir}/rabbitmq/rabbitmq.conf
%config(noreplace) %{_sysconfdir}/logrotate.d/rabbitmq-server
%{_rabbit_libdir}/
%{_unitdir}/%{name}.service
%dir /usr/lib/ocf/resource.d/rabbitmq/
/usr/lib/ocf/resource.d/rabbitmq/rabbitmq-server
%{_tmpfilesdir}/%{name}.conf
%dir %attr(0750, rabbitmq, rabbitmq) %{_localstatedir}/lib/rabbitmq
%dir %attr(0750, rabbitmq, rabbitmq) %{_localstatedir}/log/rabbitmq
%dir %attr(0755, rabbitmq, rabbitmq) %{_localstatedir}/run/rabbitmq
%{_mandir}/man5/rabbitmq-env.conf.5*
%{_mandir}/man8/rabbitmq-diagnostics.8*
%{_mandir}/man8/rabbitmq-echopid.8*
%{_mandir}/man8/rabbitmq-plugins.8*
%{_mandir}/man8/rabbitmq-server.8*
%{_mandir}/man8/rabbitmq-service.8*
%{_mandir}/man8/rabbitmq-streams.8*
%{_mandir}/man8/rabbitmq-queues.8*
%{_mandir}/man8/rabbitmq-upgrade.8*
%{_mandir}/man8/rabbitmqctl.8*


%changelog
* Fri Nov 15 2024 jackeyji <jackeyji@tencent.com> - 3.12.11-1
- [Type] security
- [DESC] upgrade to 3.12.11 to fix CVE-2024-51988

* Fri Aug 16 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 3.12.10-2
- Rebuilt for loongarch release

* Mon Dec 11 2023 Upgrade Robot <upbot@opencloudos.org> - 3.12.10-1
- Upgrade to version 3.12.10

* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 3.11.10-4
- Rebuilt for OpenCloudOS Stream 23.09

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 3.11.10-3
- Rebuilt for OpenCloudOS Stream 23.05

* Tue Apr 11 2023 cunshunxia <cunshunxia@tencent.com> - 3.11.10-2
- bump release.

* Thu Mar 30 2023 cunshunxia <cunshunxia@tencent.com> - 3.11.10-1
- initial build
